//--------------------------------------------------------
//	 AECWin32.C
//		 -- Displays " hh:mm:ss:ff" in client area
//		   AND the AECDLL.DLL Revision Number. 
//		   This code shows how to call the DLL to implement an
//			interrupt service rountine
//
//		This code has had some 'tightening' by one of our end users
//		Bryant Eastham at e&s, 6/30/97
//
//	REVISION: JULY 3, 1997
//   "	// **NEW**  " will be found where changes have been made
//--------------------------------------------------------

#include <windows.h>
#include <winioctl.h>		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "resource.h"

#include "CAecBrd.h"	// has #include "AEC_NTTC.h"
		//PROTOTYPES OF CAec class and the AECPC-TC.DLL FUNCTIONS

char sVerBase[250];
char sVersionNum[15] = "Version 1.0";
char sVersion[200] = "Adrienne Electronics Corporation\n\n"
			"Windows 32bit Test Demo Program\n"
			"for PC-TC time code boards,\n"
			"with sample source code written\n"
			"in Visual C++4.0\n\n";


#define SIO_TIMEOUT 2000	//millisecond timeout value 10 is the "standard"

#define READSTR 0
#define READDAT READSTR + 1
#define READUDAT READSTR + 2
#define GENSTR	3
#define GENDAT GENSTR + 1
#define GENUDAT GENSTR + 2
#define	VIDSTR	6
#define	VIDDAT	VIDSTR + 1
#define RBYTESSTR	8
#define RBYTESDAT	RBYTESSTR + 1
#define WBYTESSTR	10
#define WBYTESDAT	WBYTESSTR + 1
#define SCSTR		12
#define SCDAT		SCSTR + 1

#define POLLED_RX		0
#define INTERRUPT_RX	1
#define OPTIONAL_RX		2


 
// declare Adrienne Electronics classes
CAec tc1;
CTimer tmr1, tmrSIO, tmrVid, tmrRDRup, tmrGENup, tmrVIDup, tmrSioPoll;
CStrHex sh1, shSIO;

//typedef struct _AECBrdInfo
//	{
//		WORD	BrdAddr;
//		int		BrdCkType;
//		WORD	BrdModel;
//		BOOL	BrdReads;
//		PVOID	PhysAddr;
//	} AECBrdInfo, *PAECBrdInfo;
//
//VARIABLE DEFINITIONS
DWORD ReaderDat, GenDat;
char keyId;
volatile int	e_time;
int fieldcnt;

//AECBrdInfo	AecBoard[3];	// hold data for UP TO three time code boards
							// that are found (if they are installed).
//int		BoardsFound;		// number of boards found in 'find all'
int		boardNum;			// number of boards found in registry
int		aecint;
int		IntIndex, IntCnt1, IntCntBak1;
char	hhmmssff[30], dllinfo[70];		//data string to hold formated unpacked dataC
char	sCatBufR[50], sCatBufSC[10], sCatBufW[50];
char	charStr[20], rev[2];//character string to hold data sent to screen

char title_str[80] = "AEC Win32 Test Application ";

//BYTE	rByte1, rByte2, rByte3;
//BYTE	bCom, bRet; // **NEW**
BOOL	returnval, returnval1, ok, bClassRet;
//WORD	Brd1addr, Brd2addr, Brd3addr;
LPSTR	lpPassToAECDLLrev;	// typedef  char FAR*	LPSTR  
DWORD	RetDw, dwOld, dwNew; //, IORdw;
HANDLE	hWinRT2;
//volatile BOOL tc1.exiting = FALSE;
//int min = 999;
//int max = 0;
//int count = 0;
//LARGE_INTEGER last = {0, 0};
//LARGE_INTEGER frequency;

LONG 	xCharAve, yChar; 
RECT	rectB[20];
int		iButton;
char	sBuffer[10];
char	sOffset[3];
BOOL	bR1, bR4, bW1, bW4, bSC, bWrite;
BYTE	BRone, BWone;
DWORD	dRfour, dWfour;
WORD	wOffset;
int		iFieldsTotal;
int 	iFieldsPS;
//float	iFieldsPS;

//Serial Option stuff
//	tmrSIO is the timer to use for 10ms timeout
int		rxIndex, iTimeOutEvents, iRxTimeOutEvents, rx_mode;
BYTE	rxStatByte, iOldRxLen;
char	sAckStr[20], sLtcStr[20], sCtlStr[20], sVitcStr[20], sStatStr[20];
LPSTR	lpRXbuffer;
LPBOOL	lpRxDone, lpRxBusy;
BOOL	bAckBusy, bAckDone, bLtcBusy, bLtcDone, bCtlBusy, bCtlDone;
BOOL	bVitcBusy, bVitcDone, bStatBusy, bStatDone;
BYTE	hh, mm, ss, ff, speed, Nak;
BOOL	bVitcTime, bLtcTime, bCtlTime;
BOOL	bTxPlay, bTxStop, bTxRew, bTxFwd, bTxRec, bTxPause, bTxGoto;
BOOL	bTxVarRew, bTxVarFwd;
BOOL	bTmr10, bTimeOut10, RXready, okRX, TCturn;
WORD	wRX;
DWORD	dwScratch;
char	sScratch[20];

					
					//FUNCTION PROTOTYPES
DWORD	TcISR1(HANDLE);	//my 1 isr
RECT 	MakeRect(LONG, LONG, LONG);
void	TOut(HDC, RECT, char*);
void	TOutRJ(HDC, RECT, char*);	//Right Justified
BOOL	RxSonyDone(LPSTR, int);		//check to see if string is complete
void	InitSerialVariables();
BOOL	ProcSerial(void);
BOOL	ProcessRXready(HWND, int);
BOOL	ProcessIntCode(BYTE, HWND);
void	ProcessRow(BYTE, int);		//bit field, row of STATUS
void	SetStatus(BYTE, int); 		// bit(set/not set), identifier of control
BOOL	ProcessStatus(void);			// Set all of the STATUS FLAGS as needed




TEXTMETRIC tm;             /* structure for text metrics    */ 
static DWORD dwCharX;      /* average width of characters   */ 
static DWORD dwCharY;      /* height of characters          */ 
static DWORD dwClientX;    /* width of client area          */ 
static DWORD dwClientY;    /* height of client area         */ 
RECT	rClient;

HWND hwndSIO = NULL;	//handle for SIO option
HWND hwndAecRG1 = NULL;
//HWND hinstSIO;	//for serial option window

BOOL CALLBACK AecRG1(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AecSIO(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ReadWrite(HWND, UINT, WPARAM, LPARAM);
long WINAPI WndProc (HWND, UINT, UINT, LONG) ;
	    //window proceedure (WndProc) PROTOTYPE
HDC			hdc;				
PAINTSTRUCT	ps;					
RECT		rect;
RECT		r[40];				
MSG			msg;	//Global message structure that several
				    // functions use as a parameter
HANDLE hThisInst;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int WINAPI WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
{

	HMENU		hMenu;
    HWND		hwnd ;
    WNDCLASS	wndclass ;
	int i;

	HANDLE hThreadTcISR1;       // Thread TcISR handle
	DWORD  threadIdTcISR1;              // ID of thread TcISR
	static char title_id[40];
	char AddrStr[10];
	//char title_str[80] = "AEC Win32 Test Application ";

	iButton = IDC_SC;
	*sOffset = 0;
	*sBuffer = 0;
	*sCatBufR = 0;
	*sCatBufW = 0;
	*sCatBufSC = 0;


	hThisInst = hInstance;
	tc1.exiting = FALSE; //default value
	returnval1 = FALSE;

	boardNum = tc1.GetCountRegistered();	//
    static char szAppName[] = "AEC Win32" ;	//char*	GetStrId(char* str);
	if (tc1.GetCountFound() != 0)
	{
		strcat(title_str, tc1.GetStrId(title_id));
		strcat(title_str, " (Address ");
		strcat(title_str, sh1.WStr(tc1.BrdAddr(), AddrStr));
		strcat(title_str, ")");
	}
	else 	strcat(title_str, "(no board found)");

    lpPassToAECDLLrev = (LPSTR) &rev;
	aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
	wsprintf (dllinfo,"AEC_NTTC.DLL Rev. %c%c - ", rev[0], rev[1]);
	if (tc1.GetCountFound() != 0)
	{
		strcat(dllinfo, tc1.GetStrId(title_id));
		strcat(dllinfo, " (Address ");
		strcat(dllinfo, sh1.WStr(tc1.BrdAddr(), AddrStr));
		strcat(dllinfo, ")");
	}
	else  	strcat(dllinfo, "(no board found)");


		//uses the AEC_NTTC.DLL.  It passes the DLL revision 

	//QueryPerformanceFrequency ( &frequency );



    hdc = GetDC(hInstance); 
    GetTextMetrics(hdc, &tm); 
    ReleaseDC(hInstance, hdc); 
	xCharAve = tm.tmAveCharWidth; 
    yChar = tm.tmHeight; 


//--------------


    if (!hPrevInstance)  //used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS ;		
	  wndclass.lpfnWndProc	 = WndProc ;				
	  wndclass.cbClsExtra	 = 0 ;					
	  wndclass.cbWndExtra	 = 0 ;					
	  wndclass.hInstance	 = hInstance ;				
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	
	  wndclass.lpszMenuName  = NULL ;	//Points to a null-terminated character 
					//string that specifies the resource name of the class menu, 
					//as the name appears in the resource file.			
	  wndclass.lpszClassName = szAppName ;				
	  RegisterClass (&wndclass) ;				
	  }


	hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU1));
		//LPCTSTR  lpMenuName	// menu name string or menu-resource identifier  
    hwnd = CreateWindow(
		    szAppName,				// address of registered class name
		    title_str,				// window text
		    //WS_OVERLAPPEDWINDOW,	// window dwStyle
			WS_SYSMENU | WS_MINIMIZEBOX | WS_BORDER,
		    10, //CW_USEDEFAULT,			// initial x position
		    10, //CW_USEDEFAULT,			// initial y position
		    558, //CW_USEDEFAULT,			// window width
		    242, //CW_USEDEFAULT,			// window height
            NULL,					// parent window handle
            hMenu, //NULL,*N*		// window menu handle	HMENU  hMenu,
            hInstance,				// program instance handle
		    NULL) ;					// creation parameters
	if (hwnd == NULL)
		return FALSE;

		// **NEW**
		// This is important!! Make this program has the Priority that you
		// want it to have. I have decided that I want this program to run
		// as close as possible to REAL_TIME (highest Priority)
		// or interrupts will not be processed quickly enough
	SetPriorityClass ( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );

////--------------  create a new thread to use as this board's ISR
//	if ( Brd1addr != 0x0000 )
	{
//		returnval1 = AEC_PCTC_INIT_BRD_INT (&hWinRT2, &IntIndex, &Brd1addr);
		if (returnval1)	// if not fail
		{
			hThreadTcISR1  = CreateThread(NULL, 0, 
                            (LPTHREAD_START_ROUTINE)TcISR1, hWinRT2,
                            CREATE_SUSPENDED, &threadIdTcISR1);
			// This is important!! Make this Thread have highest Priority
			//		or interrupts will not be processed quickly enough
			SetThreadPriority(hThreadTcISR1, THREAD_PRIORITY_TIME_CRITICAL);
		}
	}

////-------------- 
// DO NOT START THE THREAD EXECUTION YET !!!
// PUT THE SMART BOARD INTO IDLE MODE AND CLEAR ALL THE BOARDS INTERRUPTS 
// BEFORE STARTING THREADS
////--------------

	//ClearAllInts(BoardsFound);			// put smart boards in idle mode
										//  and clear all pending ints.

            // Start up the isr threads
	if (returnval1)	// if not fail
		RetDw = ResumeThread(hThreadTcISR1); // start this thread now
	//RetDw = SuspendThread(hThreadTcISR1); //pause the ISR (stop execution) 

/*
	//RECT 	MakeRect(LONG colum, LONG row, LONG length)	//
	r[READSTR] = MakeRect(0, 0, 20);
	r[READDAT] = MakeRect(20, 0, 40);
	r[READUDAT] = MakeRect(40, 0, 60);

	r[GENSTR] = MakeRect(0, 1, 20);
	r[GENDAT] = MakeRect(20, 1, 40);
	r[GENUDAT] = MakeRect(40, 1, 60);

	r[VIDSTR] = MakeRect(0, 2, 20);
	r[VIDDAT] = MakeRect(20, 2, 40);
//RBYTESSTR	 RBYTESDAT	WBYTESSTR WBYTESDAT	SCSTR  SCDAT
	r[RBYTESSTR] = MakeRect(0, 4, 20);
	r[RBYTESDAT] = MakeRect(20, 4, 40);
	r[WBYTESSTR] = MakeRect(0, 5, 20);
	r[WBYTESDAT] = MakeRect(20, 5, 40);
	r[SCSTR] = MakeRect(0, 6, 20);
	r[SCDAT] = MakeRect(20, 6, 40);
*/


    ShowWindow (hwnd, nCmdShow) ;	 //part of the window creation
	//ShowWindow (hwnd, SW_MAXIMIZE);

    UpdateWindow (hwnd) ;			 //part of the window creation

	//tc1.ComTimeout = 1000;
	//tmr1.Zero();
	//tc1.Write1(0x02, 0x03FF);	//reset
	//Sleep(1000);

	InitSerialVariables();

	tc1.Write1(0x01F, 0x03F0);	//set int enables (all but Compartator)
	tc1.Idle();
	for (i=0; i<8; i++)
	{
		tc1.Write1(0x00, 0x03FD);	//clear int flag
		tc1.SendCom(0x00);			//reset interrupts
	}
	//RG1 send message to open RG1 dialog box
	SendMessage(hwnd, WM_COMMAND, ID_AEC_RG1, 0);
    GetMessage (&msg, NULL, 0, 0);			

//Start of the Do-While GetMessage Loop
    do
	{
//		if (!IsWindow(hwndSIO) || !IsDialogMessage(hwndSIO, &msg) || 
//			!IsWindow(hwndAecRG1) || !IsDialogMessage(hwndAecRG1, &msg)) 
//		{
//			TranslateMessage (&msg) ;				
//			DispatchMessage (&msg) ;				
//		}
	//	if (!IsWindow(hwndAecRG1) || !IsDialogMessage(hwndAecRG1, &msg)) 
	//	{
			TranslateMessage (&msg) ;				
			DispatchMessage (&msg) ;				
	//	}

//Start of the Do-While PeekMessage inner Loop
		do
		{	
			Sleep(1);	//allow windows overhead to have a turn
main_poll:
			//This is what the poll loop must do:
				//Look for data @3FD != 0.
				//Read interrupt code data @3FE. 
				//Process int code.

			if (bTmr10) 
			{
				if ((i = tmrSIO.msT()) > SIO_TIMEOUT)	//tmrSIO.Zero(); bTmr10 = TRUE;
				{
					bTimeOut10 = TRUE;
					bTmr10 = FALSE;
					*lpRxDone = FALSE;
					*lpRxBusy = FALSE;
					//MessageBox(hwnd, "Timeout Error", "Serial IO", MB_OK);
					Sleep(20);
				}
			}

main_poll2:
			if (tc1.Read1(0x03FD) != 0x00)
			{
				ProcessIntCode(tc1.Read1(0x03FE), hwnd);
				if (*lpRxBusy) 
					goto main_poll;		//hurry and go back an check for
											// more interrutps to process										
				else goto main_poll2;
			}
			else if (RXready && IsWindow(hwndSIO))
			{
				if (ProcessRXready(hwnd, rx_mode))
					goto main_poll;				
			}			
				// Start to process user Serial control requests
			else if (IsWindow(hwndSIO)) 
			{
				//if (
				ProcSerial(); //)
					//goto main_poll;		//hurry and go back an check for
												// more interrutps to process
			}
//			if (*lpRxBusy)
//				goto main_poll;
		}
		while (!PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE));
	}
    while (GetMessage (&msg, NULL, 0, 0));		
 
	TranslateMessage (&msg) ;					
    DispatchMessage (&msg) ;					

		tc1.exiting = TRUE;
		// TODO: Force an interrupt to make sure ISR loop ends.
		// --> For 'Smart' boards, just send a command to 3FF
		//		this will cause an interrupt
		//Purpose: This will allow the ISR thread to exit cleanly
		//			without leaving residual effects 
		tc1.SendCom(0x81);	// will generate an int (will NAK if no SERIAL 
		// option on board. Choose any Command wanted ie: 0x16 = idle

		if ( returnval1 )
			WaitForSingleObject ( hThreadTcISR1, 1000 );

    return msg.wParam ; 						
    }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//WINDOW PROC
long WINAPI WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
{

     switch (message)						
          {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			
		  GetClientRect (hwnd, &rect) ;			
		
/*
		  if ((tc1.ReadsLtc()) || (tc1.ReadsVitc() ) )
		  {
			TOutRJ(hdc, r[READSTR], "Reader  =  ");
			sh1.DWStrTm(tc1.Read4(0x0000), hhmmssff);
			TOut(hdc, r[READDAT], hhmmssff);
			sh1.DWStrTm(tc1.Read4(0x0000), hhmmssff);
			if (tc1.BrdModel() == 0x50)
				sh1.DWStrTm(tc1.Read4(0x0004), hhmmssff);
			else sh1.DWStrTm(tc1.Read4(0x0010), hhmmssff);
			TOut(hdc, r[READUDAT], hhmmssff);			 
		  }

		  if ((tc1.GensLtc()) || (tc1.GensVitc() ) )
		  {
			TOutRJ(hdc, r[GENSTR], "Generator  =  ");
			sh1.DWStrTm(tc1.Read4(0x0050), hhmmssff);
			TOut(hdc, r[GENDAT], hhmmssff);
			sh1.DWStrTm(tc1.Read4(0x0060), hhmmssff);
			TOut(hdc, r[GENUDAT], hhmmssff);
		  }
//	int		BrdType();					//+ 1=IOR,2=MMR,3=SMART 
//	BYTE	BrdModel();					//+ offset 3EF (VLTC=50h,VITC=93h,LTC=98h)
//	BOOL	ReadsLtc();					//+	return LRdr
//	BOOL	ReadsVitc();				//+	return VRdr
//	BOOL	GensLtc();					//+	return LGen
//	BOOL	GensVitc();					//+	return VGen


		  if ((tc1.ReadsVitc()) || (tc1.GensLtc()) || (tc1.GensVitc()))
		  {
			TOutRJ(hdc, r[VIDSTR], "Field Interupts  =  ");
			wsprintf (hhmmssff,"%6d", fieldcnt);
			TOut(hdc, r[VIDDAT], hhmmssff);
		  }
	 

			TOutRJ(hdc, r[RBYTESSTR], "Read (off/data)  =  ");
			TOutRJ(hdc, r[WBYTESSTR], "Write (off/data)  =  ");
			TOutRJ(hdc, r[SCSTR], "Last Command  =  ");

			TOut(hdc, r[RBYTESDAT], sCatBufR);
			TOut(hdc, r[WBYTESDAT], sCatBufW);
			TOut(hdc, r[SCDAT], sCatBufSC);

*/


//		if	(IntCntBak1 < IntCnt1)
//		{
//			IntCntBak1 = IntCnt1;
//			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
//		       hhmmssff,		//print the number of interrupts that each
//		       wsprintf (hhmmssff,"%d   %d   %d", //of the ISRs have processed
//			   IntCnt1, count, max), // **NEW** prints out int timing info Too.
//		       &rect,
//		       DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);
//		}
//	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//			DrawText (hdc,			//PRINT THE DLL REV TO WINDOW
//			   dllinfo,
//			   wsprintf (dllinfo,"AEC_NTTC.DLL Rev. %c%c",
//		 	   rev[0], rev[1]),
//		       &rect,
//		       DT_SINGLELINE  | DT_BOTTOM | DT_RIGHT);
//		
			EndPaint (hwnd, &ps) ;					//WO
	        return 0 ;								//WO

	  case WM_CHAR:
		  switch (wParam) {
		  case '0':
			  tc1.Start(0x23595700);
			  return 0;							
			  break;

		  case '2':
			  tc1.Write1(0x01, 0x0048); //set to sync to video
			  tc1.LRnGMode();
			  tc1.Start();
			  return 0;							
			  break;

		  case 'g':
		  case 'G':
			  tc1.AutoGen();
			  tc1.Start();
			  return 0;							
			  break;
		  case 'r':
		  case 'R':
			  tc1.Start();
			  return 0;							
			  break;

		  case 's':
		  case 'S':
			  tc1.StopGen();
			  return 0;							
			  break;

		  case 'x':
		  case 'X':
			  //e_time = tmr1.msT();
			  tc1.ResetBrd();	//reset board
			  Sleep(500);		// wait for board to initialize
			  tc1.Write1(0x07, 0x03F0);	//set int enables
			  return 0;							
			  break;


		  case 'u':
		  case 'U':
			  //e_time = tmr1.msT();
			  InvalidateRect ( hwnd, NULL, 0 );
			  return 0;							
			  break;
		  default:
			  return 0;							
			  break;
		  }

	case WM_COMMAND:

		switch(LOWORD(wParam)) {
			//MODE CONTROL
			case IDCLOSE:
				exit(0);
				break;
				case ID_MENU_SC_ACK: // 00
					bClassRet = tc1.EnableNext();
					return 0;
					break;

				case ID_MENU_SC_RESET: // 02
				//case ID_TIMECODEMODE_RESET:
					bClassRet = tc1.ResetBrd();
					Sleep(500);
					tc1.Write1(0x3F, 0x03F0);	//set int enables
					return 0;
					break;

				case ID_MENU_SC_SMPTE: // 03
				//case ID_TIMECODEMODE_SMPTENTSC:
					bClassRet = tc1.Smpte(); // SMPTE/NTSC
					return 0;
					break;

				case ID_MENU_SC_EBU: // 04
				//case ID_TIMECODEMODE_EBUPAL:
					bClassRet = tc1.Ebu(); // EBU/PAL
					return 0;
					break;

				case ID_MENU_SC_IDLE: // 16/20
				//case ID_TIMECODEMODE_IDLE:
					bClassRet = tc1.Idle();
					return 0;
					break;

				case ID_MENU_SC_AUTOREADMODE: // 10/23
				//case ID_MODECONTROL_READTIMECODE:
					bClassRet = tc1.AutoRead(); //autoread
					return 0;
					break;

				case ID_MENU_SC_AUTOGENMODE: // 18/2C
				//case ID_MODECONTROL_GENTIMECODE:
					bClassRet = tc1.AutoGen(); //autogen
					return 0;
					break;

				case ID_MENU_SC_LTCJAM: // 1A
					bClassRet = tc1.LJam(); // send jam reader data into gen
					return 0;
					break;

				case ID_MENU_SC_LTCREADMODE: // 21/10
					bClassRet = tc1.LReadMode(); // ltc reader mode only
					return 0;
					break;

				case ID_MENU_SC_VITCREADMODE: // 22/10
					bClassRet = tc1.VReadMode(); // vitc only read mode
					return 0;
					break;

				case ID_MENU_SC_LTCGENMODE: // 24/18
					bClassRet = tc1.LGenMode(); // gen ltc only
					return 0;
					break;

				case ID_MENU_SC_LTCRGMODE: // 18/25
					bClassRet = tc1.LRnGMode();	// read and gen ltc simultaneously
					return 0;
					break;

				case ID_MENU_SC_VTOLTRAN: // 26
				//case ID_MODECONTROL_TRANSVTOL:
					bClassRet = tc1.VtoLMode(); //translate VITC-to-LTC
					return 0;
					break;

				case ID_MENU_SC_VITCGENMODE: //28 
					bClassRet = tc1.VGenMode(); // vitc only gen mode
					return 0;
					break;

				case ID_MENU_SC_LTOVTRAN: // 29
				//case ID_MODECONTROL_TRANSLTOV:
					bClassRet = tc1.LtoVMode(); //translate LTC-to-VITC
					return 0;
					break;

				case ID_MENU_SC_JAMGENALL: // 40
					bClassRet = tc1.JamTU(); // jam time and user
					return 0;
					break;

				case ID_MENU_SC_JAMGENTIME: // 41
					bClassRet = tc1.JamTB(); // jam time only
					return 0;
					break;

				case ID_MENU_SC_JAMGENUSER: // 42
					bClassRet = tc1.JamUB(); // jam user only
					return 0;
					break;

				case ID_MENU_SC_GENRUN: // 48
					bClassRet = tc1.Start(); // make sure in gen mode and start generator 
					return 0;
					break;

				case ID_MENU_SC_GENSTOP: // 49
					bClassRet = tc1.StopGen(); // stop tc gen
					return 0;
					break;





/*


			case ID_TIMECODEMODE_IDLE:
				tc1.Idle();
				return 0;
				break;

			case ID_TIMECODEMODE_RESET:
				tc1.ResetBrd();
				Sleep(500);
				tc1.Write1(0x07, 0x03F0);	//set int enables
				return 0;
				break;
			
			case ID_TIMECODEMODE_SMPTENTSC:
				tc1.Smpte(); // SMPTE/NTSC
				return 0;
				break;

			case ID_TIMECODEMODE_EBUPAL:
				tc1.Ebu(); // EBU/PAL
				return 0;
				break;

			case ID_MODECONTROL_READTIMECODE:
				tc1.AutoRead(); //autoread
				return 0;
				break;

			case ID_MODECONTROL_GENTIMECODE:
				tc1.AutoGen(); //autogen
				return 0;
				break;

			case ID_MODECONTROL_TRANSLTOV:
				tc1.LtoVMode(); //translate LTC-to-VITC
				return 0;
				break;

			case ID_MODECONTROL_TRANSVTOL:
				tc1.VtoLMode(); //translate VITC-to-LTC
				return 0;
				break;
*/

			case ID_AEC_VERSION_INFO:
				sVerBase[0] = 0;
				strcat(sVerBase, sVersion);
				strcat(sVerBase, sVersionNum);
				MessageBox(hwnd, sVerBase, "About AecWin32", MB_OK);
				return 0;
				break;

			case ID_SERIALOPTION:
				if (!tc1.HasSerial())
					MessageBox(NULL, "NOT Installed", "SERIAL Option", MB_OK);
				else if (!IsWindow(hwndSIO)) {
					//rx_mode = POLLED_RX;	//used in INITDIALOG
					//rx_mode = INTERRUPT_RX;
					rx_mode = OPTIONAL_RX;

					hwndSIO = CreateDialog(hThisInst, //hinstSIO,
						MAKEINTRESOURCE(IDD_XSERIAL_OPTION),
						hwnd, (DLGPROC)AecSIO);
					ShowWindow(hwndSIO, SW_SHOW);
				}
				return 0;
				break;
			case ID_AEC_RG1:
				if (!IsWindow(hwndAecRG1)) {
					hwndAecRG1 = CreateDialog(hThisInst, //hinstSIO,
						MAKEINTRESOURCE(IDD_AEC_RG1),
						hwnd, (DLGPROC)AecRG1);
					if (IsWindow(hwndAecRG1)) {
//						SetWindowText(hwndAecRG1, title_str ); 
						SetWindowText(GetDlgItem(hwndAecRG1, AEC_DLL_INFO), dllinfo );
						ShowWindow(hwndAecRG1, SW_SHOW);
					}
				}
				else 
				{
					DestroyWindow(hwndAecRG1);
					hwndAecRG1 = NULL;
				}
				return 0;
				break;


			//READ/WRITE
/*			case ID_READWRITE:
				if (DialogBox(hThisInst,
					MAKEINTRESOURCE(IDD_DIALOG_RW),
					hwnd, (DLGPROC)ReadWrite) == IDOK)
				{
					if (bR1){
						wOffset = (WORD)sh1.ToHex(sOffset);
						BRone = tc1.Read1(wOffset);
						//DISPLAY DATA
						sh1.BStr(BRone, hhmmssff);
						sCatBufR[0] = 0;
						strcat(sCatBufR, sOffset);
						strcat(sCatBufR, "  ");
						strcat(sCatBufR, hhmmssff);
						//TOut(hdc, r[RBYTESDAT], sCatBufR);
						InvalidateRect ( hwnd, &r[RBYTESDAT], 0 );

					}
					if (bR4){
						wOffset = (WORD)sh1.ToHex(sOffset);
						dRfour = tc1.Read4(wOffset);
						//DISPLAY DATA
						sh1.DWStr(dRfour, hhmmssff);
						sCatBufR[0] = 0;
						strcat(sCatBufR, sOffset);
						strcat(sCatBufR, "  ");
						strcat(sCatBufR, hhmmssff);
						//TOut(hdc, r[RBYTESDAT], sCatBufR);
						InvalidateRect ( hwnd, &r[RBYTESDAT], 0 );
					}
					if (bW1){
						BWone = (BYTE)sh1.ToHex(sBuffer);
						wOffset = (WORD)sh1.ToHex(sOffset);
						bWrite = tc1.Write1(BWone, wOffset);
						//DISPLAY DATA/status
						sCatBufW[0] = 0;
						strcat(sCatBufW, sOffset);
						strcat(sCatBufW, "  ");
						strcat(sCatBufW, sBuffer);
						//TOut(hdc, r[WBYTESDAT], sCatBufW);
						InvalidateRect ( hwnd, &r[WBYTESDAT], 0 );
					}
					if (bW4){
						dWfour = (DWORD)sh1.ToHex(sBuffer);
						wOffset = (WORD)sh1.ToHex(sOffset);
						bWrite = tc1.Write4(dWfour, wOffset);
						//DISPLAY DATA/status
						sCatBufW[0] = 0;
						strcat(sCatBufW, sOffset);
						strcat(sCatBufW, "  ");
						strcat(sCatBufW, sBuffer);
						//TOut(hdc, r[WBYTESDAT], sCatBufW);
						InvalidateRect ( hwnd, &r[WBYTESDAT], 0 );
					}
					if (bSC){
						BWone = (BYTE)sh1.ToHex(sBuffer);
						bWrite = tc1.SendCom(BWone);
						//DISPLAY DATA/ack
						//sh1.BStr(BRone, hhmmssff);
						sCatBufW[0] = 0;
						strcat(sCatBufSC, sBuffer);
						//TOut(hdc, r[SCDAT], sCatBufSC);
						InvalidateRect ( hwnd, &r[SCDAT], 0 );
					}
				}
				//else MessageBox(NULL, "ReadWrite", "FALSE", MB_OK);
				return 0;
				break;
*/			
			default:
			  return 0;							
			  break;
		}


	  case WM_DESTROY:								
	       PostQuitMessage (0) ;					
	       return 0 ;								
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	
}



// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// // **NEW** Some changes have been made to this routine to allow for safe
//		exiting and to determine the intervals between interrupts
//		by Bryant Easham...

DWORD TcISR1(HANDLE hWinRT)		//board1
{
	//LARGE_INTEGER now;

	while ( ! tc1.exiting )		//THIS 'WHILE' LOOP IS THE ISR FOR THE FIRST
								//BOARD.  THIS EXAMPLE ONLY UPDATES A
								//COUNTER THAT SHOWS THE NUMBER OF
								//INTERRUPTS THAT HAVE OCCURED.  THIS ISR
								//DOES NOT ATTEMT TO DISTINGUISH WHAT
								//CAUSES THE INTERRUPT.  THIS CODE DOES
								//ASSUME THAT THE BOARD IS CAPABLE OF
								//READING TIME CODE.  IF DIFFERENT CODE
								//PATHS NEED TO BE TAKEN, USE 'if' OR 
								//'switch/case' TO CONTROL THE ISR PROGRAM
								//FLOW BASED UPON THE RETURN VALUE 'rByte'
								//THE ISR WILL LOOP INDEFINITLY.  TO STOP
								//THE ISR, MAKE A CALL TO STOP THE ISR
								//THREAD!, and to exit, set the exiting flag!
	{  

//			rByte1 = AEC_PCTC_ISR_1 (&Brd1addr); // wait for interrupt
		Sleep(100);

		++IntCnt1;
/*		QueryPerformanceCounter(&now);
		if ( last.QuadPart )
		{
			DWORD n = (DWORD) ((now.QuadPart - last.QuadPart) / (frequency.QuadPart / 1000));
//			if ( n < min )
//				min = n;
//			if ( n > max )
//				max = n;	// **NEW***
//			if ( n > 17 )	// may need to change this value if not detecting
//				count += 1;	// 60 /Second video field rate interrupt.
							//    Use '34' for 30 frame reader/gen
							//    Use '41' for 25 frame reader/gen (PAL)
							//    Use '21' for 50 field video rate interrupt (PAL)
		}
		last.QuadPart = now.QuadPart;
*/
    }
    return(NO_ERROR);       // can't get here until tc1.exiting is TRUE
}



// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
RECT 	MakeRect(LONG colum, LONG row, LONG length)
{
	RECT rc;

	rc.left = (colum * xCharAve);
	rc.top = (row * yChar);
	rc.right = ((colum + length) * xCharAve);
	rc.bottom = ((row + 1) * yChar);
	return rc;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void TOut(HDC hdc, RECT rc, char* str)
{

	int x, y, len;
	x = rc.left;
	y = rc.top;
	for (len = 0; str[len] != 0; ++len);
	TextOut(hdc, x, y, str, len); 
	return;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void TOutRJ(HDC hdc, RECT rc, char* str)	//Right Justified
{
	BOOL ok;
	SIZE strSize;
		//strSize.cx = xwidth
		//strSize.cy = yheight
	int x, y, len;

	for (len = 0; str[len] != 0; ++len);
	ok = GetTextExtentPoint32(hdc, str, len, &strSize);
	y = rc.top;
	x = rc.right - strSize.cx;
	TextOut(hdc, x, y, str, len); //r[0]
	return;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL RxSonyDone(LPSTR lpRxSonyBuff, int iIndex)
{
	BOOL done;
	BYTE cmd1;
	int iCount;

	done = FALSE;	//default
	cmd1 = lpRxSonyBuff[0];
	iCount = (int)(cmd1 & 0x0F) + 3;
	if (iCount == iIndex)
		done = TRUE;
	return done;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL CALLBACK AecSIO(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	BOOL ok;
	static char sHH[3], sMM[3], sSS[3], sFF[3];
	//BYTE hh, mm, ss, ff;
	CStrHex CVtr;
	//HWND hwndTest;

	ok = TRUE;	// will change if "default" 
	switch (message) {
		case WM_INITDIALOG:
			//
			if (rx_mode == OPTIONAL_RX)
			{
				tc1.Write1(0x00, 0x0104);	// set DPRAM Rx buffer to point to 0x0200
				tc1.Write1(0x02, 0x0105);	//   Using the Optional Rx method
				iOldRxLen = 0x00;	//reset Rx index counter
			}
			else	//POLLED_RX or INTERRUPT_RX
			{
				tc1.Write1(0x00, 0x0104);	// set the Rx buffer to default operation
				tc1.Write1(0x00, 0x0105);
			}

			InitSerialVariables();
			iTimeOutEvents =0;
			iRxTimeOutEvents = 0;
			ok = CheckRadioButton(hwndDlg, IDC_XCTL, IDC_XVITC, IDC_XLTC);
			bLtcTime = TRUE;
			SetDlgItemText(hwndDlg, IDC_XGOTOTIMEHH, "01");
			SetDlgItemText(hwndDlg, IDC_XGOTOTIMEMM, "00");
			SetDlgItemText(hwndDlg, IDC_XGOTOTIMESS, "00");
			SetDlgItemText(hwndDlg, IDC_XGOTOTIMEFF, "00");
			tmrSioPoll.Zero();

			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_XPLAY:
//					SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B0, //play
//	                    BM_SETCHECK, 1, 0); 
//					SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B5, //stop
//	                    BM_SETCHECK, 0, 0); 
//					SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B7, //stby
//	                    BM_SETCHECK, 2, 0); 							
					bTxPlay = FALSE;
					ok = TRUE;
					break;
				case IDC_XSTOP:
//					SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B0, 
//						BM_SETCHECK, 0, 0); 
//					SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B5, 
//						BM_SETCHECK, 1, 0); 
//					SendDlgItemMessage(hwndDlg, IDC_X_ROW1_B7, 
//						BM_SETCHECK, 0, 0); 
					bTxStop = FALSE;
					ok = TRUE;
					break;
				case IDC_XPAUSE:
					bTxPause = FALSE;
					ok = TRUE;
					break;
				case IDC_XRECORD:
					bTxRec = FALSE;
					ok = TRUE;
					break;
				case IDC_XREW:
					bTxRew = FALSE;
					ok = TRUE;
					break;
				case IDC_XFFWD:
					bTxFwd = FALSE;
					ok = TRUE;
					break;
				case IDC_XGOTO:
						// read the first two characters of each box
					GetDlgItemText(hwndDlg, IDC_XGOTOTIMEHH, sHH, 3);
					GetDlgItemText(hwndDlg, IDC_XGOTOTIMEMM, sMM, 3);
					GetDlgItemText(hwndDlg, IDC_XGOTOTIMESS, sSS, 3);
					GetDlgItemText(hwndDlg, IDC_XGOTOTIMEFF, sFF, 3);
						// clean up text boxes (clears if more than 2)
					SetDlgItemText(hwndDlg, IDC_XGOTOTIMEHH, sHH);
					SetDlgItemText(hwndDlg, IDC_XGOTOTIMEMM, sMM);
					SetDlgItemText(hwndDlg, IDC_XGOTOTIMESS, sSS);
					SetDlgItemText(hwndDlg, IDC_XGOTOTIMEFF, sFF);
					//ADD code here to check for valid user input
					// if error then do MessageBox...
					  //MessageBox(hwndDlg, "GOTO not executed\n, BAD HH:MM:SS:FF data", 
					  //			"SERIAL Option", MB_OK);
					//else
					hh = CVtr.IntBcdByte(atoi(sHH));
					mm = CVtr.IntBcdByte(atoi(sMM));
					ss = CVtr.IntBcdByte(atoi(sSS));
					ff = CVtr.IntBcdByte(atoi(sFF));
					bTxGoto = FALSE;
					ok = TRUE;
					break;
				case IDC_XCTL:
					bCtlTime = TRUE;
					bLtcTime = FALSE;
					bVitcTime = FALSE;
					ok = TRUE;
					break;
				case IDC_XLTC:
					bLtcTime = TRUE;
					bCtlTime = FALSE;
					bVitcTime = FALSE;
					ok = TRUE;
					break;
				case IDC_XVITC:
					bVitcTime = TRUE;
					bLtcTime = FALSE;
					bCtlTime = FALSE;
					ok = TRUE;
					break;
				case IDCANCEL:
					//MessageBeep(MB_ICONASTERISK);
					DestroyWindow(hwndDlg);
					hwndSIO = NULL;
					ok = TRUE;
					break;
				default:
					ok = FALSE;

			return ok;
			}
	}
	return FALSE;
}			

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL CALLBACK ReadWrite(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	BOOL ok;
	switch (message){

		case WM_INITDIALOG:
			ok = CheckRadioButton(hwndDlg, IDC_R1, IDC_SC, iButton);
				// IDC_R1 , IDC_R4, IDC_W1, IDC_W4, IDC_SC
			SetDlgItemText(hwndDlg, IDC_EDIT_OFFSET, sOffset);
			SetDlgItemText(hwndDlg, IDC_EDIT_DATA, sBuffer);
			return ok;
			//break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					if (IsDlgButtonChecked(hwndDlg, IDC_R1)) {
						iButton = IDC_R1;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_OFFSET, sOffset, 4))
							*sOffset = 0;
						*sBuffer = 0;
						//MessageBox(NULL, "R1", sOffset, MB_OK);
						bR1 = TRUE; //FALSE;
						bR4 = FALSE;
						bW1 = FALSE;
						bW4 = FALSE;
						bSC = FALSE;
					}
					else if (IsDlgButtonChecked(hwndDlg, IDC_R4)) {
						iButton = IDC_R4;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_OFFSET, sOffset, 4))
							*sOffset = 0;
						*sBuffer = 0;
						//MessageBox(NULL, "R4", sOffset, MB_OK);
						bR1 = FALSE;
						bR4 = TRUE; //FALSE;
						bW1 = FALSE;
						bW4 = FALSE;
						bSC = FALSE;

					}
					else if (IsDlgButtonChecked(hwndDlg, IDC_W1)) {
						iButton = IDC_W1;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_OFFSET, sOffset, 4))
							*sOffset = 0;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_DATA, sBuffer, 3))
							*sBuffer = 0;
						//MessageBox(NULL, sOffset, sBuffer, MB_OK);
						bR1 = FALSE;
						bR4 = FALSE;
						bW1 = TRUE; //FALSE;
						bW4 = FALSE;
						bSC = FALSE;

					}
					else if (IsDlgButtonChecked(hwndDlg, IDC_W4)) {
						iButton = IDC_W4;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_OFFSET, sOffset, 4))
							*sOffset = 0;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_DATA, sBuffer, 9))
							*sBuffer = 0;
						//MessageBox(NULL, sOffset, sBuffer, MB_OK);
						bR1 = FALSE;
						bR4 = FALSE;
						bW1 = FALSE;
						bW4 = TRUE; //FALSE;
						bSC = FALSE;

					}
					else if (IsDlgButtonChecked(hwndDlg, IDC_SC)) {
						iButton = IDC_SC;
						*sOffset = 0;
						if (!GetDlgItemText(hwndDlg, IDC_EDIT_DATA, sBuffer, 3))
							*sBuffer = 0;
						//MessageBox(NULL, "SC", sBuffer, MB_OK);
						bR1 = FALSE;
						bR4 = FALSE;
						bW1 = FALSE;
						bW4 = FALSE;
						bSC = TRUE; //FALSE;

					}
					else {
						bR1 = FALSE;
						bR4 = FALSE;
						bW1 = FALSE;
						bW4 = FALSE;
						bSC = FALSE;
						MessageBox(NULL, "NO Option Button Selected", 
						"ReadWrite", MB_OK);
					//break; // no break, let fall through
					}
				case IDCANCEL:
					EndDialog(hwndDlg, wParam);
					return TRUE;
			}
	}
	return FALSE;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL CALLBACK AecRG1(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	char cBuff[15];
	BYTE IntEnables, Embedded_R, Embedded_G;
	BOOL ok; //, bClassRet;
	BOOL bReadOff, bVidOff, bGenOff, bCmpOff;
	//static char sHH[3], sMM[3], sSS[3], sFF[3];
	//BYTE hh, mm, ss, ff;
	//CStrHex CStrRG1;

	ok = TRUE;	// will change if "default" 
	switch (message) {
		case WM_INITDIALOG:
			if ((tc1.ReadsLtc()) || (tc1.ReadsVitc() ) )
			{
				SetDlgItemText(hwndDlg, AEC_DEF_TIME, "HH:MM:SS:FF");
				SetDlgItemText(hwndDlg, AEC_DEF_USER, "HH:MM:SS:FF");
				SetDlgItemText(hwndDlg, AEC_DEF_DF, "??");
				SetDlgItemText(hwndDlg, AEC_DEF_CF, "??");
				tmrRDRup.Zero();
			}
			else
			{
				SetDlgItemText(hwndDlg, AEC_DEF_TIME, "No Time Code");
				SetDlgItemText(hwndDlg, AEC_DEF_USER, "Reader");
				SetDlgItemText(hwndDlg, AEC_DEF_DF, "NA");
				SetDlgItemText(hwndDlg, AEC_DEF_CF, "NA");
			}

			if ( (tc1.GensLtc()) || (tc1.GensVitc()) )
			{
				SetDlgItemText(hwndDlg, AEC_GEN_TIME, "HH:MM:SS:FF");
				SetDlgItemText(hwndDlg, AEC_GEN_USER, "HH:MM:SS:FF");
				SetDlgItemText(hwndDlg, AEC_GEN_DF, "??");
				tmrGENup.Zero();
			}
			else
			{
				SetDlgItemText(hwndDlg, AEC_GEN_TIME, "No Time Code");
				SetDlgItemText(hwndDlg, AEC_GEN_USER, "Generator");
				SetDlgItemText(hwndDlg, AEC_GEN_DF, "NA");
			}


			//if board has video sync input
			if ( (tc1.GensLtc()) || (tc1.GensVitc()) || (tc1.ReadsVitc()))
			{
				SetDlgItemText(hwndDlg, AEC_VID_FPS, "0");
				SetDlgItemText(hwndDlg, AEC_VID_FRAMES, "0");
				tmrVIDup.Zero();
			}
			else	// no video sync
			{
				SetDlgItemText(hwndDlg, AEC_VID_FPS, "N/A");
				SetDlgItemText(hwndDlg, AEC_VID_FRAMES, "N/A");
				tmrVIDup.Zero();
			}


			SetDlgItemText(hwndDlg, AEC_SC_CMD, "00");
			SetDlgItemText(hwndDlg, AEC_SC_ACK, " ");

			SetDlgItemText(hwndDlg, AEC_R1_ADDR, "3FE");
			SetDlgItemText(hwndDlg, AEC_R1_DATA, " ");
			SetDlgItemText(hwndDlg, AEC_R4_ADDR, "000");
			SetDlgItemText(hwndDlg, AEC_R4_DATA, " ");

			SetDlgItemText(hwndDlg, AEC_W1_ADDR, "3F0");
			SetDlgItemText(hwndDlg, AEC_W1_DATA, "3F ");
			SetDlgItemText(hwndDlg, AEC_W4_ADDR, "060");
			SetDlgItemText(hwndDlg, AEC_W4_DATA, "12:15:19:97");

			SetDlgItemText(hwndDlg, AEC_CMP_TIME, "01:15:00:00");

			return TRUE;
			break;

		case WM_COMMAND:
			ok = TRUE;
			switch (LOWORD(wParam)) {
				//MODE CONTROL
				case AEC_DEF_UPDATE:
					if ((tc1.ReadsLtc()) || (tc1.ReadsVitc() ) )
					{
						if (tmrRDRup.msT() > 211)	//only update so often at max
						{
							sh1.DWStrTm(tc1.Read4(0x0000), hhmmssff);
							SetDlgItemText(hwndDlg, AEC_DEF_TIME, hhmmssff);
							if (tc1.BrdModel() == 0x50)
							{
								sh1.DWStrTm(tc1.Read4(0x0004), hhmmssff);
								Embedded_R = tc1.Read1(0x0008);
							}
							else 
							{
								sh1.DWStrTm(tc1.Read4(0x0010), hhmmssff);
								Embedded_R = tc1.Read1(0x000C);
							}

							SetDlgItemText(hwndDlg, AEC_DEF_USER, hhmmssff);
							if (Embedded_R & 0x80)
								SetDlgItemText(hwndDlg, AEC_DEF_DF, "Yes");	//FINISH
							else SetDlgItemText(hwndDlg, AEC_DEF_DF, "No");

							if (Embedded_R & 0x40)
								SetDlgItemText(hwndDlg, AEC_DEF_CF, "Yes");	// ""
							else SetDlgItemText(hwndDlg, AEC_DEF_CF, "No");
							tmrRDRup.Zero();
						}
					}
					break;
				case AEC_GEN_UPDATE:
					if ( (tc1.GensLtc()) || (tc1.GensVitc()) )
					{
						if (tmrGENup.msT() > 233)   //only update so often at max
						{
							sh1.DWStrTm(tc1.Read4(0x0050), hhmmssff);
							SetDlgItemText(hwndDlg, AEC_GEN_TIME, hhmmssff);
							sh1.DWStrTm(tc1.Read4(0x0060), hhmmssff);				
							Embedded_G = tc1.Read1(0x004C);
							SetDlgItemText(hwndDlg, AEC_GEN_USER, hhmmssff);
							if (Embedded_G & 0x80)
								SetDlgItemText(hwndDlg, AEC_GEN_DF, "Yes");	
							else SetDlgItemText(hwndDlg, AEC_GEN_DF, "No");	
							tmrGENup.Zero();
						}
					}
					break;

				case AEC_VID_UPDATE:
					switch(LOWORD(lParam)) {
						case 1:
							iFieldsTotal++;
							if (tmrVIDup.msT() > 187)   //only update so often at max
							{
								wsprintf (cBuff,"%d",iFieldsTotal);
								SetDlgItemText(hwndDlg, AEC_VID_FRAMES, cBuff); 
								tmrVIDup.Zero();
							}
							break;
						default:
							if ( (tc1.GensLtc()) || (tc1.GensVitc()) || 
								(tc1.ReadsVitc()))
							{
								iFieldsPS = ((1000 * iFieldsTotal) / 
									(tmrVid.msT())) + 1; // + 1 is for round UP
								wsprintf (cBuff,"%d",iFieldsPS);
								SetDlgItemText(hwndDlg, AEC_VID_FPS, cBuff);
								tmrVIDup.Zero();
							}
							break;
					}
					break;

				case AEC_VID_RESET:
					//if board has video sync input
					if ( (tc1.GensLtc()) || (tc1.GensVitc()) || (tc1.ReadsVitc()))
					{
						SetDlgItemText(hwndDlg, AEC_VID_FPS, "0");
						SetDlgItemText(hwndDlg, AEC_VID_FRAMES, "0");
						iFieldsTotal = 0;
						iFieldsPS = 0;
						tmrVIDup.Zero();
						tmrVid.Zero();
					}
					else	// no video sync
					{
						SetDlgItemText(hwndDlg, AEC_VID_FPS, "N/A");
						SetDlgItemText(hwndDlg, AEC_VID_FRAMES, "N/A");
						tmrVIDup.Zero();
					}
					break;

				case AEC_SC_GO:
					//if (!GetDlgItemText(hwndDlg, IDC_EDIT_OFFSET, sOffset, 4))
					//	*sOffset = 0;
					if (GetDlgItemText(hwndDlg, AEC_SC_CMD, sBuffer, 3))
					{						
						BWone = (BYTE)sh1.ToHex(sBuffer);
						bWrite = tc1.SendCom(BWone);
						if (!bWrite)	// if error, read ack
							BWone = tc1.Read1(0x03FE);
						sh1.BStr(BWone, hhmmssff);
						SetDlgItemText(hwndDlg, AEC_SC_CMD, sBuffer);
						SetDlgItemText(hwndDlg, AEC_SC_ACK, hhmmssff);
					}
					else SetDlgItemText(hwndDlg, AEC_SC_CMD, "Err");
					break;

				case AEC_R1_GO:
					if (GetDlgItemText(hwndDlg, AEC_R1_ADDR, sOffset, 4))
					{
						wOffset = (WORD)sh1.ToHex(sOffset);
						if (wOffset < 0x400)
						{
							BRone = tc1.Read1(wOffset);
							//DISPLAY DATA
							sh1.BStr(BRone, hhmmssff);
							//sCatBufR[0] = 0;
							//strcat(sCatBufR, sOffset);
							//strcat(sCatBufR, "  ");
							//strcat(sCatBufR, hhmmssff);
	
							SetDlgItemText(hwndDlg, AEC_R1_DATA, hhmmssff);
						}
						else SetDlgItemText(hwndDlg, AEC_R1_DATA, "Err");
					}
					else SetDlgItemText(hwndDlg, AEC_R1_DATA, "Err");					
					break;

				case AEC_R4_GO:
					if (GetDlgItemText(hwndDlg, AEC_R4_ADDR, sOffset, 4))
					{
						wOffset = (WORD)sh1.ToHex(sOffset);
						if (wOffset < 0x3FC)
						{
							dRfour = tc1.Read4(wOffset);
							//DISPLAY DATA
							sh1.DWStrTm(dRfour, hhmmssff);
							//sCatBufR[0] = 0;
							//strcat(sCatBufR, sOffset);
							//strcat(sCatBufR, "  ");
							//strcat(sCatBufR, hhmmssff);

							SetDlgItemText(hwndDlg, AEC_R4_DATA, hhmmssff);
						}
						else  SetDlgItemText(hwndDlg, AEC_R4_DATA, "Addr Error");
					}
					else  SetDlgItemText(hwndDlg, AEC_R4_DATA, " Error ");					
					break;

				case AEC_W1_GO:
					if ((GetDlgItemText(hwndDlg, AEC_W1_ADDR, sOffset, 4)) && 
						    (GetDlgItemText(hwndDlg, AEC_W1_DATA, sBuffer, 3)))
					{
						BWone = (BYTE)sh1.ToHex(sBuffer);
						wOffset = (WORD)sh1.ToHex(sOffset);
						if (wOffset < 0x400)
						{
							bWrite = tc1.Write1(BWone, wOffset);
							//DISPLAY DATA/status
							//sCatBufW[0] = 0;
							//strcat(sCatBufW, sOffset);
							//strcat(sCatBufW, "  ");
							//strcat(sCatBufW, sBuffer);
							//TOut(hdc, r[WBYTESDAT], sCatBufW);
							sh1.BStr(BWone, hhmmssff);
							SetDlgItemText(hwndDlg, AEC_W1_DATA, hhmmssff);
						}
						else SetDlgItemText(hwndDlg, AEC_W1_ADDR, "AEr");
					}
					else SetDlgItemText(hwndDlg, AEC_W1_ADDR, "Err");
					break;

				case AEC_W4_GO:
					if ((GetDlgItemText(hwndDlg, AEC_W4_ADDR, sOffset, 4)) && 
						    (GetDlgItemText(hwndDlg, AEC_W4_DATA, sBuffer, 12)))
					{
						dWfour = (DWORD)sh1.ToHex(sBuffer);
						wOffset = (WORD)sh1.ToHex(sOffset);
						if (wOffset < 0x3FC)
						{
							bWrite = tc1.Write4(dWfour, wOffset);
							//DISPLAY DATA/status
							//sCatBufW[0] = 0;
							//strcat(sCatBufW, sOffset);
							//strcat(sCatBufW, "  ");
							//strcat(sCatBufW, sBuffer);
							//TOut(hdc, r[WBYTESDAT], sCatBufW);
							sh1.DWStrTm(dWfour, hhmmssff);
							SetDlgItemText(hwndDlg, AEC_W4_DATA, hhmmssff);
						}
						else SetDlgItemText(hwndDlg, AEC_W4_ADDR, "Err");
					}
					else SetDlgItemText(hwndDlg, AEC_W4_DATA, "Error");
					break;

				case AEC_CMP_SET:
					if (GetDlgItemText(hwndDlg, AEC_CMP_TIME, sBuffer, 12))
					{
						// get compare string
						dWfour = (DWORD)sh1.ToHex(sBuffer);
						// write packed BCD data to compare registers
						bWrite = tc1.Write4(dWfour, 0x0090);
						// enable the comparator 
						// 0x09 = Exact match + any ">" than under 1 sec.
						bWrite = tc1.Write1(0x09, 0x0094);
					}
					break;

				case AEC_INT_READ_OFF:
				case AEC_INT_VID_OFF:
				case AEC_INT_GEN_OFF:
				case AEC_INT_CMP_OFF:
					//MessageBox(NULL, "Changed", "Interupt Enables", MB_OK);
					if (IsDlgButtonChecked(hwndDlg, AEC_INT_READ_OFF)) 
						bReadOff = TRUE; // bit 0
					else bReadOff = FALSE;
					if (IsDlgButtonChecked(hwndDlg, AEC_INT_VID_OFF)) 
						bVidOff = TRUE; // bit 1
					else bVidOff = FALSE;
					if (IsDlgButtonChecked(hwndDlg, AEC_INT_GEN_OFF)) 
						bGenOff = TRUE; // bit 2
					else bGenOff = FALSE;
					if (IsDlgButtonChecked(hwndDlg, AEC_INT_CMP_OFF)) 
						bCmpOff = TRUE;	// bit 5
					else bCmpOff = FALSE;
					IntEnables = tc1.Read1(0x3F0);
					IntEnables = (IntEnables & 0xD8); //clear bits 0,1,2 & 5.
					if (!bReadOff)
						IntEnables = (IntEnables | 0x01);
					if (!bVidOff)
						IntEnables = (IntEnables | 0x02);
					if (!bGenOff)
						IntEnables = (IntEnables | 0x04);
					if (!bCmpOff)
						IntEnables = (IntEnables | 0x20);

					ok = tc1.Write1(IntEnables, 0x3F0);
					break;

				case IDOK:
				case IDCANCEL:
				//case ID_MENU_CLOSE:
					//MessageBeep(MB_ICONASTERISK);
					DestroyWindow(hwndDlg);
					hwndAecRG1 = NULL;
					ok = TRUE;
					break;
				default:
					ok = FALSE;

			return ok;
			}
	}
	return FALSE;
}			


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL ProcSerial(void)
{
				// Start to process user Serial control requests
	if (!(*lpRxDone || *lpRxBusy)) 	//if (FALSE AND FALSE) 
	{
		if (!bTxPlay) {
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxPlay = tc1.Play();
			tmrSIO.Zero(); 
			bTmr10 = TRUE;
			lpRXbuffer = sAckStr;
		}
		else if (!bTxStop) {
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxStop = tc1.Stop();
			tmrSIO.Zero(); 
			bTmr10 = TRUE;
			lpRXbuffer = sAckStr;
		}
		else if (!bTxRew) {
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxRew = tc1.Rewind();
			tmrSIO.Zero(); 
			bTmr10 = TRUE;
			lpRXbuffer = sAckStr;
		}
		else if (!bTxFwd) {
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxFwd = tc1.FastForward();
			tmrSIO.Zero(); 
			bTmr10 = TRUE;
			lpRXbuffer = sAckStr;
		}
		else if (!bTxRec) { 
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxRec = tc1.Record();
			tmrSIO.Zero(); 
			lpRXbuffer = sAckStr;
			bTmr10 = TRUE;
		}
		else if (!bTxPause) { 
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxPause = tc1.Pause();
			tmrSIO.Zero(); 
			bTmr10 = TRUE;
			lpRXbuffer = sAckStr;
		}
		else if (!bTxGoto) {
			lpRxBusy = &bAckBusy;
			lpRxDone = &bAckDone;
			bAckBusy = TRUE;
			tc1.InitRx();
			iOldRxLen = 0x00;	//reset Rx index counter
			bTxGoto = tc1.Cue(hh, mm, ss, ff);
			tmrSIO.Zero(); 
			bTmr10 = TRUE;
			lpRXbuffer = sAckStr;
		}
		//else if (!bTxVarRew)
		//else if (!bTxVarFwd)

		else // check on time and status
		{
			// set case to rotate selected TC and Status
			if (tmrSioPoll.msT() > 300)
			{
				tmrSioPoll.Zero();
				if (TCturn)
				{
					TCturn = FALSE;
					if (bLtcTime){
						lpRxBusy = &bLtcBusy;
						lpRxDone = &bLtcDone;
						bLtcBusy = TRUE;
						tc1.InitRx();
						iOldRxLen = 0x00;	//reset Rx index counter
						ok = tc1.LTCc();
						tmrSIO.Zero(); 
						bTmr10 = TRUE;
						lpRXbuffer = sLtcStr;
					}
					else if (bCtlTime) {
						lpRxBusy = &bCtlBusy;
						lpRxDone = &bCtlDone;
						bCtlBusy = TRUE;
						tc1.InitRx();
						iOldRxLen = 0x00;	//reset Rx index counter
						ok = tc1.Tmr1();
						tmrSIO.Zero(); 
						bTmr10 = TRUE;
						lpRXbuffer = sCtlStr;
					}
					else if (bVitcTime) {
						lpRxBusy = &bVitcBusy;
						lpRxDone = &bVitcDone;
						bVitcBusy = TRUE;
						tc1.InitRx();
						iOldRxLen = 0x00;	//reset Rx index counter
						ok = tc1.VITCc();
						tmrSIO.Zero(); 
						bTmr10 = TRUE;
						lpRXbuffer = sVitcStr;
					}
				}
				else // (STATUS) 
				{
					TCturn = TRUE;
					lpRxBusy = &bStatBusy;
					lpRxDone = &bStatDone;
					bStatBusy = TRUE;
					tc1.InitRx();
					iOldRxLen = 0x00;	//reset Rx index counter
					ok = tc1.Status();
					tmrSIO.Zero(); 
					bTmr10 = TRUE;
					lpRXbuffer = sStatStr;
				}
			}
		}
		return TRUE;
	}
	else if (*lpRxDone)
	{
		if (bStatDone)
		{
			bStatDone = FALSE;
			ProcessStatus();	//sStatStr, hwndSIO
			//TEMP
			//SendDlgItemMessage(hwndSIO, IDC_X_ROW0_B0, BM_SETCHECK, 1, 0); 
		}
		else if (bLtcDone)
		{
			bLtcDone = FALSE;
			dwScratch = (DWORD)((sLtcStr[2] & 0x3F) + ((sLtcStr[3] & 0x7F) * 0x100) 
				+ ((sLtcStr[4] & 0x7F) * 0x10000) + ((sLtcStr[5] & 0x3F) * 0x1000000));
			//char* CStrHex::DWStrTm(DWORD dw, char *chs)
			//&sScratch = shSIO.DWStrTm(dwScratch, sScratch);
			shSIO.DWStrTm(dwScratch, sScratch);
			if ((sLtcStr[2] & 0x40) != 0x00)
				strcat(sScratch, "  DF");
			else strcat(sScratch, "  NDF");
			SetDlgItemText(hwndSIO, IDC_XTIMEDATA, sScratch);
			SetDlgItemText(hwndSIO, IDC_XUSERDATA, "N/A");
		}
		else if (bCtlDone)
		{
			bCtlDone = FALSE;
			dwScratch = (DWORD)((sCtlStr[2] & 0x3F) + ((sCtlStr[3] & 0x7F) * 0x100) 
				+ ((sCtlStr[4] & 0x7F) * 0x10000) + ((sCtlStr[5] & 0x3F) * 0x1000000));
			//&sScratch = shSIO.DWStrTm(dwScratch, sScratch);
			shSIO.DWStrTm(dwScratch, sScratch);
			//if ((sCtlStr[2] & 0x40) != 0x00)
			//	strcat(sScratch, "  DF");
			//else 
			strcat(sScratch, "  NDF");
			SetDlgItemText(hwndSIO, IDC_XTIMEDATA, sScratch);
			SetDlgItemText(hwndSIO, IDC_XUSERDATA, "N/A");
		}
		else if (bVitcDone)
		{
			bVitcDone = FALSE;
			//SendDlgItemMessage(hwndSIO, IDC_XTIMEDATA, WM_SETTEXT, 
			//	0, LPSTR); 
			dwScratch = (DWORD)((sVitcStr[2] & 0x3F) + ((sVitcStr[3] & 0x7F) * 0x100) 
				+ ((sVitcStr[4] & 0x7F) * 0x10000) + ((sVitcStr[5] & 0x3F) * 0x1000000));
			//sScratch = shSIO.DWStrTm(dwScratch, sScratch);
			shSIO.DWStrTm(dwScratch, sScratch);
			if ((sVitcStr[2] & 0x40) != 0x00)
				strcat(sScratch, "  DF");
			else strcat(sScratch, "  NDF");
			SetDlgItemText(hwndSIO, IDC_XTIMEDATA, sScratch);
			SetDlgItemText(hwndSIO, IDC_XUSERDATA, "N/A");
		}
		else if (bAckDone)
		{
			//SetDlgItemText(hwndSIO, IDC_XTIMEDATA, "12:34:00:00");
			bAckDone = FALSE;
			//*lpRxBusy = FALSE;
		}
		return FALSE;
	}	
	return TRUE; // n
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	InitSerialVariables()
{
	lpRxBusy = &bAckBusy;
	lpRxDone = &bAckDone;
	bAckBusy = FALSE;
	bAckDone = FALSE;	//Default settings
	bCtlDone = FALSE;
	bCtlBusy = FALSE;
	bLtcDone = FALSE;
	bLtcBusy = FALSE;
	bVitcDone = FALSE;
	bVitcBusy = FALSE;
	bTxPlay = TRUE;
	bTxStop = TRUE;
	bTxRew = TRUE;
	bTxFwd = TRUE;
	bTxRec = TRUE;
	bTxPause = TRUE;
	bTxGoto = TRUE;
	bTxVarRew = TRUE;
	bTxVarFwd = TRUE;
	lpRXbuffer = sStatStr;
	bTmr10 = FALSE;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL	ProcessRXready(HWND hwnd, int iRxType)
{
	BYTE TestData, iRxLen;	
	WORD offset;

	switch (iRxType) 
	{
		case POLLED_RX: 
			RXready = FALSE;
			// The byte that is returned will be 0x00 if no errors occured.
			// The return value will be NON-ZERO IF ERROR occurs with the error
			//  being flaged in a bitwise encoding.
			//	 bit7 = data vaild, (will only be set if bit 0, 1, or 2 are also set
			//	 bit6 = for TIMEOUT			(0x40)
			//	 bit5 = NAK					(0x20)
			//	 bit2 = buffer overflow		(0x8x)
			//	 bit1 = break character rxed	"
			//	 bit0 = parity error			"
			// The string 'S' will be loaded with the received data, without null termination
			TestData = tc1.RxSony(lpRXbuffer); //RxSony polls until full "sony" string is RXed
			if (bStatBusy)
				bStatBusy = TRUE;
			if (TestData != 0x00)
			{
				if (TestData & 0x40)	//bit6 rx timeout
				{
					//MessageBox(hwnd, "Time Out", "Serial IO", MB_OK);														
					iRxTimeOutEvents++;
					if (iRxTimeOutEvents > 10)
					{
						MessageBox(hwnd, "The VTR is NOT\nresponding correctly."
							"Check serial settings","Serial IO", MB_OK);
						// send a message to the SIO dialog box to close it
						PostMessage(hwndSIO, WM_COMMAND, IDCANCEL, 0);
					}
								}
				if (TestData & 0x20)	//bit5 rx NAK
					MessageBox(hwnd, "Nak Error", "Serial IO", MB_OK);														
				if (TestData & 0x04)	//bit2 rx buffer overflow
					MessageBox(hwnd, "Overflow Error", "Serial IO", MB_OK);														
				if (TestData & 0x02)	//bit1 break character
					MessageBox(hwnd, "Break Character", "Serial IO", MB_OK);												
				if (TestData & 0x01)	//bit0 parity error
					MessageBox(hwnd, "Parity Error", "Serial IO", MB_OK);	
				*lpRxDone = FALSE;	//will clear "DONE" if error
				//*lpRxBusy = FALSE;
			}
			else
			{
				*lpRxDone = TRUE;
				iRxTimeOutEvents = 0;
			}
			*lpRxBusy = FALSE;
			bTmr10 = FALSE;  //turn off timeout timer
			return FALSE;
			break;
				
		case INTERRUPT_RX: 			
			
			if (!bTimeOut10)
			{
				wRX = tc1.RxByte();	// wRX = WORD (data BYTE:status BYTE)
				lpRXbuffer[rxIndex] = (BYTE)(wRX/0x100);
				rxIndex++;
				if (rxIndex > 1)
					TestData = lpRXbuffer[rxIndex];
				if ((rxStatByte = (wRX & 0xFF)) != 0x80) //bit7 = data valid
				{
					if (rxStatByte & 0x04)	//bit2 rx buffer overflow
						MessageBox(hwnd, "Overflow Error", "Serial IO", MB_OK);														
					if (rxStatByte & 0x02)	//bit1 break character
						MessageBox(hwnd, "Break Character", "Serial IO", MB_OK);												
					if (rxStatByte & 0x01)	//bit0 parity error
						MessageBox(hwnd, "Parity Error", "Serial IO", MB_OK);
					*lpRxDone = FALSE;
					*lpRxBusy = FALSE;
					bTmr10 = FALSE;  //turn off timeout timer
					RXready = FALSE;
				}
				else //Put code here to process received data
				{
					if (*lpRxDone = RxSonyDone(lpRXbuffer, rxIndex))
					{
						bTmr10 = FALSE;  //turn off timeout timer
						if (okRX = tc1.CheckSonyRX(lpRXbuffer))
									//Returns FALSE if Nak or error, Else TRUE
						{
							*lpRxBusy = FALSE;
						}
						else
						{
							Nak = tc1.SonyNAK(lpRXbuffer);				
								//Returns non-zero with NAK data byte IF Nak
							if (Nak == 0x00)
								MessageBox(hwnd, "Unknown Error", "Serial IO", MB_OK);
							else 
								MessageBox(hwnd, "Nak Error", "Serial IO", MB_OK);
							*lpRxBusy = FALSE;
							*lpRxDone = FALSE;	//clear 'done' & 'busy' if errors 
						}
						RXready = FALSE;
					}
					//else RXready = TRUE; // No change
				}
				return TRUE; //
			}
			else	//TIMEOUT
			{
				RXready = FALSE;
				bTimeOut10 = FALSE;	// re-initialize
				bTmr10 = FALSE;
				*lpRxDone = FALSE;
				*lpRxBusy = FALSE;
				//MessageBox(hwnd, "TimeOut Error", "Serial IO", MB_OK);
				lpRXbuffer[10] = 0;
				MessageBox(hwnd, lpRXbuffer, "Serial IO", MB_OK);
				return FALSE;
			}		
			*lpRxBusy = FALSE;
			bTmr10 = FALSE;  //turn off timeout timer
			return FALSE;
			break;
		case OPTIONAL_RX:	// Optional DPRAM RX data buffer operations
			// check for rx at 0x200 by seeing if 0x106 does not have 0x00 value.
			// ( the 0x106 and 0x107 are pointers into the RX buffer)
			// Write the Rx buffer starting address into DPRAM offset 0x106/0x107
			// Send the init serial command (80h), Send the init RX command (81h)
			// to reset buffer pointer after each string is RXed.
			// 
			
			iRxLen = 0xFF;
			while (iRxLen != tc1.Read1(0x0106))
			{
				iRxLen = tc1.Read1(0x0106);		//make sure that 0x106 is read twice
												// and that the same values is read
				if ((rxStatByte = tc1.Read1(0x0107)) > 0x7F)	
					iRxLen = 0xFF;				// start over if bit7 (15) MSB is set
												//  It indicates "update in progress"
			}

			iRxLen = (tc1.Read1(0x0106) - tc1.Read1(0x0104));
			if (iRxLen > iOldRxLen)	// have had more rx
			{
				//process to see if have complete Rx)
				iOldRxLen = iRxLen;
				iRxLen--;	// pre decrament the index, It points to next available
				rxIndex = (int)iRxLen;
				while ( rxIndex >= 0 ) 
				{
					// this works for Rx'ed strings less than 255 bytes long
					iRxLen = (BYTE)rxIndex;
					offset = (WORD)((tc1.Read1(0x0105) * 0x100) + iRxLen);
					lpRXbuffer[rxIndex] = tc1.Read1(offset);
					rxIndex--;
				}

				rxIndex = (int)iOldRxLen;

				if ((rxStatByte & 0x50) != 0x00) //then bit6 or bit4 are set
				{
					if (rxStatByte & 0x10)	//bit4 rx buffer overflow
						MessageBox(hwnd, "Overflow Error", "Serial IO", MB_OK);														
					// Break detection is not available in this mode
					//if (rxStatByte & 0x02)	//bit1 break character
					//	MessageBox(hwnd, "Break Character", "Serial IO", MB_OK);												
					if (rxStatByte & 0x40)	//bit6 parity error
						MessageBox(hwnd, "Parity Error", "Serial IO", MB_OK);
					*lpRxDone = FALSE;
					*lpRxBusy = FALSE;
					bTmr10 = FALSE;  //turn off timeout timer
					RXready = FALSE;
					iTimeOutEvents--;
				}
				else if (*lpRxDone = RxSonyDone(lpRXbuffer, rxIndex))
				{
					bTmr10 = FALSE;  //turn off timeout timer
					if (okRX = tc1.CheckSonyRX(lpRXbuffer))
								//Returns FALSE if Nak or error, Else TRUE
					{
						*lpRxBusy = FALSE;
					}
					else
					{
						Nak = tc1.SonyNAK(lpRXbuffer);				
							//Returns non-zero with NAK data byte IF Nak
						if (Nak == 0x00)
							MessageBox(hwnd, "Unknown Error", "Serial IO", MB_OK);
						else 
							MessageBox(hwnd, "Nak Error", "Serial IO", MB_OK);
						*lpRxBusy = FALSE;
						*lpRxDone = FALSE;	//clear 'done' & 'busy' if errors 
					}
					RXready = FALSE;
					iTimeOutEvents = 0;
				}
				else  
				{
					tmrSIO.Zero(); 	//inititialize/reset 10ms timer
					//RXready = TRUE; //This is not a change
				}
									
				return TRUE; // ??
			}
			else 
			{
				// check to see have timed out
				if (bTimeOut10)
				{
					bTimeOut10 = FALSE;	// re-initialize
					bTmr10 = FALSE;
					*lpRxDone = FALSE;
					*lpRxBusy = FALSE;
					//MessageBox(hwnd, "TimeOut Error", "Serial IO", MB_OK);
					lpRXbuffer[10] = 0;
					//MessageBox(hwnd, lpRXbuffer, "Serial IO", MB_OK);
					RXready = FALSE;
					return FALSE;
				}		
				else return TRUE; // ??

			}

		default:
			return FALSE;
	}
}



// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BOOL	ProcessIntCode(BYTE IntId, HWND hwnd)
{
	switch (IntId)
	{
		case 0x13:	//time code reader ID
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
//			rect = r[READDAT];
//			InvalidateRect ( hwnd, &rect, 0 );
			tc1.SendCom(0x00);	//reset interrupts
			//SendDlgItemMessage(hwndAecRG1, AEC_DEF_UPDATE, WM_SETTEXT, 
			//	0, LPSTR); 
			if (IsWindow(hwndAecRG1))
				SendMessage(hwndAecRG1, WM_COMMAND, AEC_DEF_UPDATE, 0);
				//PostMessage(hwndAecRG1, WM_COMMAND, AEC_DEF_UPDATE, 0);
			//tc1.SendCom(0x00);	//reset interrupts

			break;
		case 0x4C:	//time code generator ID		
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
//			rect = r[GENDAT];
//			InvalidateRect ( hwnd, &rect, 0 );
			tc1.SendCom(0x00);	//reset interrupts
			if (IsWindow(hwndAecRG1))
				SendMessage(hwndAecRG1, WM_COMMAND, AEC_GEN_UPDATE, 0);
				//PostMessage(hwndAecRG1, WM_COMMAND, AEC_GEN_UPDATE, 0);
			//tc1.SendCom(0x00);	//reset interrupts
			break;
		case 0x44:	//video field ID
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
//			rect = r[VIDDAT];
//			fieldcnt++;
//			InvalidateRect ( hwnd, &rect, 0 );
			tc1.SendCom(0x00);	//reset interrupts
			if (IsWindow(hwndAecRG1))
				SendMessage(hwndAecRG1, WM_COMMAND, AEC_VID_UPDATE, 1);//lParam = 1 if int
				//PostMessage(hwndAecRG1, WM_COMMAND, AEC_VID_UPDATE, 1);//lParam = 1 if int
			//tc1.SendCom(0x00);	//reset interrupts
			break;
		case 0x88:	//RX data byte ID
				//check for 10ms timeout
				//flag error if timeout
				//Put command in Que to read byte (0x82)
				//reset 10ms timer
			if (iTimeOutEvents > 0)
				iTimeOutEvents--;
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
			tc1.SendCom(0x00);	//reset interrupts
			tmrSIO.Zero();		//reset timer
			if (*lpRxBusy) //*lpRxDone || 
				RXready = TRUE;
			break;

		case 0x89:	//TX complete ID
			iTimeOutEvents++;
			if (iTimeOutEvents > 5) 
			{
				MessageBox(hwnd, "The VTR is NOT responding."
					"\nCheck cable","Serial IO", MB_OK);
				// send a message to the SIO dialog box to close it
				PostMessage(hwndSIO, WM_COMMAND, IDCANCEL, 0);//close dialog if errors
			}

			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
			tc1.SendCom(0x00);	//reset interrupts
			//tc1.InitRx();

			rxIndex = 0;
			//inititialize/reset 10ms timer
			tmrSIO.Zero(); 
			if (*lpRxBusy && (rx_mode == OPTIONAL_RX))	// if not using rx interrupt modes
				RXready = TRUE;

			break;
	
		case 0x50:	//time code compare MATCH ID
				//set up for next compare...
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
			tc1.SendCom(0x00);	//reset interrupts
			if (IsWindow(hwndAecRG1))
				//SendMessage(hwndAecRG1, WM_COMMAND, AEC_CMD_UPDATE, 0);
				MessageBox(NULL, "MATCH!", "Time Code Comparator", MB_OK);

			break;

		case 0xF0:	// NAK  error of some sort(0xFx)
		case 0xF1:
		case 0xF2:
		case 0xF3:
		case 0xF4:
		case 0xF5:
		case 0xF6:
		case 0xF7:
		case 0xF9:
		case 0xFA:
		case 0xFB:
		case 0xFC:
		case 0xFD:
		case 0xFE:
		case 0xFF:
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
			tc1.SendCom(0x00);	//reset interrupts
			break;
		case 0xF8:	//VGWE_Int, vitc generator write error ID
					//put code here to flag this error
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
			tc1.SendCom(0x00);	//reset interrupts
			break;
	
		default:
			// ISR processing of command response interrupts
				// NOT used if using polling method!
			// ProcessCommandResponse(tc1.Read1(0x03FE));
			tc1.Write1(0x00, 0x03FD);	//clear int flag for next time
			tc1.SendCom(0x00);	//reset interrupts
			break;
	} //END of Interrupt ID cases
	return TRUE;
}
					//hurry and go back an check for
					// more interrutps to process										

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	SetStatus(BYTE bStatBit, int  nID) 	// identifier of control
{
//	if (bStatBit == 0x00) //Clear
//		PostMessage(GetDlgItem(hwndSIO, nID), BM_SETCHECK, 0, 0);
//	else 	//Set
//		PostMessage(GetDlgItem(hwndSIO, nID), BM_SETCHECK, 1, 0);
//

	if (bStatBit == 0x00) //Clear
		SendMessage(GetDlgItem(hwndSIO, nID), BM_SETCHECK, 0, 0);
	else 	//Set
		SendMessage(GetDlgItem(hwndSIO, nID), BM_SETCHECK, 1, 0);

}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	ProcessRow(BYTE bBits, int StatRow)	//bit field, row
{
	if (StatRow == 0)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW0_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW0_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW0_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW0_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW0_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW0_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW0_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW0_B0);
	}
	else if (StatRow == 1)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW1_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW1_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW1_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW1_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW1_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW1_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW1_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW1_B0);
	}
	else if (StatRow == 2)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW2_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW2_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW2_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW2_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW2_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW2_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW2_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW2_B0);
	}
	else if (StatRow == 3)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW3_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW3_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW3_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW3_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW3_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW3_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW3_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW3_B0);
	}
	else if (StatRow == 4)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW4_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW4_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW4_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW4_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW4_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW4_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW4_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW4_B0);
	}
	else if (StatRow == 5)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW5_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW5_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW5_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW5_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW5_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW5_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW5_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW5_B0);
	}
	else if (StatRow == 6)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW6_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW6_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW6_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW6_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW6_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW6_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW6_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW6_B0);
	}
	else if (StatRow == 7)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW7_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW7_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW7_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW7_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW7_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW7_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW7_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW7_B0);
	}
	else if (StatRow == 8)
	{
		SetStatus((bBits & BIT_7), IDC_X_ROW8_B7);
		SetStatus((bBits & BIT_6), IDC_X_ROW8_B6);
		SetStatus((bBits & BIT_5), IDC_X_ROW8_B5);
		SetStatus((bBits & BIT_4), IDC_X_ROW8_B4);
		SetStatus((bBits & BIT_3), IDC_X_ROW8_B3);
		SetStatus((bBits & BIT_2), IDC_X_ROW8_B2);
		SetStatus((bBits & BIT_1), IDC_X_ROW8_B1);
		SetStatus((bBits & BIT_0), IDC_X_ROW8_B0);
	}
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Process the Status string that the VTR has returned and update the status flags
// This program was written such that the status is hard coded to ask for status
// bytes 0 through 8 (nine bytes total) and so this function processes the string as
// if this is the case
BOOL	ProcessStatus()	//sStatStr, hwndSIO
{
	static BYTE Row0, Row1, Row2, Row3, Row4, Row5, Row6, Row7, Row8;
	BYTE Rw0, Rw1, Rw2, Rw3, Rw4, Rw5, Rw6, Rw7, Rw8;
	int nLen;

	if ((sStatStr[0] & 0x09) != 0x09)
//		return FALSE;	//did not receive data properly
		nLen = (int)(sStatStr[0] & 0x0F);

	Rw0 = sStatStr[2];// != Row0)
	Rw1 = sStatStr[3];
	Rw2 = sStatStr[4];
	Rw3 = sStatStr[5];
	Rw4 = sStatStr[6];
	Rw5 = sStatStr[7];
	Rw6 = sStatStr[8];
	Rw7 = sStatStr[9];
	Rw8 = sStatStr[10];

	if (Rw0 != Row0)
	{
		ProcessRow(sStatStr[2], 0);	//bit field, row
		Row0 = sStatStr[2];
	}
	//else if ((sStatStr[3]) != Row1)
	else if (Rw1 != Row1)
	{
		ProcessRow(sStatStr[3], 1);	//bit field, row
		Row1 = sStatStr[3];
	}
	//else if (sStatStr[4] != Row2)
	else if (Rw2 != Row2)
	{
		ProcessRow(sStatStr[4], 2);	//bit field, row
		Row2 = sStatStr[4];
	}
	//else if (sStatStr[5] != Row3)
	else if (Rw3 != Row3)
	{
		ProcessRow(sStatStr[5], 3);	//bit field, row
		Row3 = sStatStr[5];
	}
	//else if (sStatStr[6] != Row4)
	else if (Rw4 != Row4)
	{
		ProcessRow(sStatStr[6], 4);	//bit field, row
		Row4 = sStatStr[6];
	}
	//else if (sStatStr[7] != Row5)
	else if (Rw5 != Row5)
	{
		ProcessRow(sStatStr[7], 5);	//bit field, row
		Row5 = sStatStr[7];
	}
	//else if (sStatStr[8] != Row6)
	else if (Rw6 != Row6)
	{
		ProcessRow(sStatStr[8], 6);	//bit field, row
		Row6 = sStatStr[8];
	}
	//else if (sStatStr[9] != Row7)
	else if (Rw7 != Row7)
	{
		ProcessRow(sStatStr[9], 7);	//bit field, row
		Row7 = sStatStr[9];
	}
	//else if (sStatStr[10] != Row8)
	else if (Rw8 != Row8)
	{
		ProcessRow(sStatStr[10], 8);	//bit field, row
		Row8 = sStatStr[10];
	}

	return TRUE;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Void ProcessCommandResponse(BYTE ID)
					//Command acknowledgement - USE if move code to ISR thread
					// NOT used in polling loop!
/*
	switch(ID) {	
		case ...
							SMPTE (0x03)			// ALL smart
							EBU (0x04)		
							READ_MODE (0x10)		// LTC and VITC only
							IDLE (0x16)				//ALL smart
							GEN_MODE (0x18)			// LTC and VITC only
							OTltcJam (0x1A)			// LTC and VLTC only
							IDLE (0x20)				//VLTC only
							READ_LTC_MODE (0x21)	// VLTC only
							READ_VITC_MODE (0x22)	// VLTC only
							READ_AUTO_MODE (0x23)	// VLTC only
							GEN_LTC_MODE (0x24)		// VLTC only
							RG_LTC_MODE (0x25)		// VLTC only
							VtoL_MODE (0x26)		// VLTC only
							GEN_VITC_MODE (0x28)	// VLTC only
							LtoV_MODE (0x29)		// VLTC only
							GEN_LV_MODE (0x2C)		// VLTC only
						//	DIAG_MODE (0x3x)		// ALL smart
							LOAD_GEN_ALL_MODE (0x40)// ALL smart
							LOAD_GEN_TC_MODE (0x41)	// ALL smart
							LOAD_GNE_UB_MODE (0x42)	// ALL smart
							START_GEN_MODE (0x48)	// ALL smart
							STOP_GEN_MODE (0x49)	// ALL smart
							INIT_UART (0x80)		// SERIAL
							INIT_RX (0x81)			// SERIAL
							READ_RX (0x82)			// SERIAL
								Store the byte read into a string pointed to 
								by a variable.
								SET flag if finished receiving response
								SET NAK if error
							TX_STAT (0x90)			// SERIAL 
							TX_422_EN (0x91)		// SERIAL
							TX_422_DIS (0x92)		// SERIAL
							TX_BREAK (0x93)			// SERIAL
							TX_ONE (0xA0)			// SERIAL
							TX_STR_1 (0xA1)			//SERIAL
							TX_STR_2 (0xA2)			//SERIAL
							TX_STR_3 (0xA3)			//SERIAL
							TX_STR_4 (0xA4)			//SERIAL
							TX_STR_5 (0xA5)			//SERIAL
							TX_STR_6 (0xA6)			//SERIAL
							TX_STR_7 (0xA7)			//SERIAL
							TX_STR_8 (0xA8)			//SERIAL
							TX_STR_9 (0xA9)			//SERIAL
							TX_STR_A (0xAA)			//SERIAL
							TX_STR_B (0xAB)			//SERIAL
							TX_STR_C (0xAC)			//SERIAL
							TX_STR_D (0xAD)			//SERIAL
							TX_STR_E (0xAE)			//SERIAL
							TX_STR_F (0xAF)			//SERIAL
*/


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	      // END OF CODE	END OF CODE		END OF CODE
